USE [UITest]
GO
/****** Object:  Schema [Audit]    Script Date: 5/16/2023 2:20:35 PM ******/
CREATE SCHEMA [Audit]
GO
/****** Object:  Schema [msi]    Script Date: 5/16/2023 2:20:35 PM ******/
CREATE SCHEMA [msi]
GO
/****** Object:  Table [Audit].[T_DM_DATAHEADER]    Script Date: 5/16/2023 2:20:35 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [Audit].[T_DM_DATAHEADER](
	[AUDIT_TYPE] [varchar](20) NULL,
	[AUDIT_USER] [varchar](100) NULL,
	[AUDIT_TIME_UTC] [datetime] NOT NULL,
	[ID] [int] NULL,
	[DATAHEADER_DB_ID] [varchar](10) NULL,
	[DATAMASTER_DB_ID] [varchar](9) NULL,
	[DATAHEADER_ID] [varchar](3) NULL,
	[DATAHEADER_DESC] [varchar](200) NULL,
	[IS_ENABLED] [bit] NULL,
	[NOTE] [varchar](2000) NULL
) ON [PRIMARY]
GO
/****** Object:  Table [msi].[T_DM_DATAHEADER]    Script Date: 5/16/2023 2:20:35 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [msi].[T_DM_DATAHEADER](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[DATAHEADER_DB_ID]  AS ('DTH'+right('000000'+CONVERT([varchar](6),[ID]),(6))) PERSISTED NOT NULL,
	[DATAMASTER_DB_ID] [varchar](9) NOT NULL,
	[DATAHEADER_ID] [varchar](5) NULL,
	[DATAHEADER_DESC] [varchar](200) NULL,
	[IS_ENABLED] [bit] NOT NULL,
	[NOTE] [varchar](2000) NULL,
 CONSTRAINT [Pk_T_DM_DATAHEADER_DATAHEADER_DB_ID] PRIMARY KEY CLUSTERED 
(
	[DATAHEADER_DB_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY],
 CONSTRAINT [UNQ_T_DM_DATAHEADER_DATAHEADER_ID_DATAMASTER_DB_ID] UNIQUE NONCLUSTERED 
(
	[DATAHEADER_ID] ASC,
	[DATAMASTER_DB_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [msi].[T_DM_DATAMASTER]    Script Date: 5/16/2023 2:20:35 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [msi].[T_DM_DATAMASTER](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[DATAMASTER_DB_ID]  AS ('DTM'+right('000000'+CONVERT([varchar](6),[ID]),(6))) PERSISTED NOT NULL,
	[DATAMASTER_CODE] [varchar](20) NOT NULL,
	[DAILYCUTOFFDAYOFFSET] [smallint] NOT NULL,
	[DAILYCUTOFFTIME] [time](7) NOT NULL,
	[DAILYKICKOFFDAYOFFSET] [smallint] NOT NULL,
	[DAILYKICKOFFTIME] [time](7) NOT NULL,
	[DAILYCYCLETIMEZONE] [varchar](100) NOT NULL,
	[IS_ENABLED] [bit] NOT NULL,
	[NOTE] [varchar](2000) NULL,
	[DATAMASTER_LONGNAME] [varchar](200) NOT NULL,
 CONSTRAINT [Pk_T_DM_DATAMASTER_DATAMASTER_DB_ID] PRIMARY KEY CLUSTERED 
(
	[DATAMASTER_DB_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY],
 CONSTRAINT [UNQ_T_DM_DATAMASTER_DATAMASTER_CODE] UNIQUE NONCLUSTERED 
(
	[DATAMASTER_CODE] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
ALTER TABLE [Audit].[T_DM_DATAHEADER] ADD  CONSTRAINT [defo_T_DM_DATAHEADER_AUDIT_TIME]  DEFAULT (sysdatetime()) FOR [AUDIT_TIME_UTC]
GO
ALTER TABLE [msi].[T_DM_DATAHEADER]  WITH CHECK ADD  CONSTRAINT [FK_T_DM_DATAHEADER_DATAMASTER_DB_ID] FOREIGN KEY([DATAMASTER_DB_ID])
REFERENCES [msi].[T_DM_DATAMASTER] ([DATAMASTER_DB_ID])
GO
ALTER TABLE [msi].[T_DM_DATAHEADER] CHECK CONSTRAINT [FK_T_DM_DATAHEADER_DATAMASTER_DB_ID]
GO
ALTER TABLE [msi].[T_DM_DATAHEADER]  WITH CHECK ADD  CONSTRAINT [CHK_T_DM_DATAHEADER_DATAHEADER_ID] CHECK  ((NOT [DATAHEADER_ID] like '%[^A-Z0-9_]%'))
GO
ALTER TABLE [msi].[T_DM_DATAHEADER] CHECK CONSTRAINT [CHK_T_DM_DATAHEADER_DATAHEADER_ID]
GO
ALTER TABLE [msi].[T_DM_DATAMASTER]  WITH CHECK ADD  CONSTRAINT [CHK_T_DM_DATAMASTER_APP_CODE] CHECK  ((NOT [DATAMASTER_CODE] like '%[^A-Z0-9_]%'))
GO
ALTER TABLE [msi].[T_DM_DATAMASTER] CHECK CONSTRAINT [CHK_T_DM_DATAMASTER_APP_CODE]
GO
/****** Object:  Trigger [msi].[TR_DATAHEADER]    Script Date: 5/16/2023 2:20:35 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE TRIGGER [msi].[TR_DATAHEADER] ON [msi].[T_DM_DATAHEADER]  
AFTER INSERT ,UPDATE,DELETE
AS  
IF (ROWCOUNT_BIG() = 0)
RETURN;

DECLARE @INSCOUNT INT
DECLARE @ERROR_MSG  VARCHAR(MAX) =''
DECLARE @INVALID_KEYS VARCHAR(MAX) =''
SELECT @INSCOUNT = COUNT(*) FROM Inserted


INSERT INTO [Audit].[T_DM_DATAHEADER] 
	(AUDIT_TYPE,
	AUDIT_USER,
	AUDIT_TIME_UTC,
	ID,
	DATAHEADER_DB_ID,
	DATAMASTER_DB_ID,
	DATAHEADER_ID,
	DATAHEADER_DESC,
	IS_ENABLED,
	NOTE)
SELECT 
	CASE WHEN EXISTS (SELECT 1 FROM Deleted) THEN 'UPDATED' ELSE 'INSERTED' END,
	SUSER_NAME(),
	GETDATE(),
	I.ID,
	I.DATAHEADER_DB_ID,
	I.DATAMASTER_DB_ID,
	I.DATAHEADER_ID,
	I.DATAHEADER_DESC,
	I.IS_ENABLED,
	I.NOTE
FROM
   Inserted I
UNION ALL
SELECT
	'DELETED',
	SUSER_NAME(),
	GETDATE(),
	D.ID,
	D.DATAHEADER_DB_ID,
	D.DATAMASTER_DB_ID,
	D.DATAHEADER_ID,
	D.DATAHEADER_DESC,
	D.IS_ENABLED,
	D.NOTE
FROM Deleted D
WHERE NOT EXISTS (
   SELECT * FROM INSERTED
);
RETURN   



GO
ALTER TABLE [msi].[T_DM_DATAHEADER] ENABLE TRIGGER [TR_DATAHEADER]
GO
